; #INDEX# =======================================================================================================================
; Title .........: CheckProcess
; AutoIt Version : 3.3
; Language ......: English
; Description ...: Checks if processes are running which has to be closed before installation can start
; Author ........: DigitalKarl
; Date ..........: 21.06.2017
; ===============================================================================================================================

#include <ButtonConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <ColorConstants.au3>
#include <MsgBoxConstants.au3>

;## Application which get installed
$Application="Application with Office integration XY"

;## Processnames to check if they are running
$ProcessName1="outlook.exe"
$ProcessName2="winword.exe"
$ProcessName3="excel.exe"
$ProcessName4=""

;## Processnames which gets displayed when they are running
$ProcessToClose1="Microsoft Outlook"
$ProcessToClose2="Microsoft Word"
$ProcessToClose3="Microsoft Excel"
$ProcessToClose4=""

;## Variables
$postponeStatus = 0
$postponeCounter = 2
$minMultiplier = 60000
$testMultiplier = 60
$continue = 0

;# Sets the postponemultiplier - set $testMultiplier to only wait seconds isntead of minutes
$postponeIntMultiplier = $testMultiplier


If ProcessExists ($ProcessName1) or ProcessExists ($ProcessName2) or ProcessExists ($ProcessName3) or ProcessExists ($ProcessName4) Then

#Region ### START GUI section ###
	  $Main = GUICreate("CompanyName - Software Installation", 410, 510, -1, -1,BitOr($WS_BORDER, $WS_POPUP), BitOR($WS_EX_TOPMOST, $WS_EX_TOOLWINDOW))
	  GUISetBkColor(0xFFFFFF)
	  $iBkClr = 0xE6E6E6
	  $company_logo = GUICtrlCreatePic(@ScriptDir &"\logo.gif", 104, 15, 200, 70)
	  GUICtrlCreateButton("", 8, 96, 393, 273)
	  GUICtrlSetBkColor(-1, $iBkClr)
	  GUICtrlSetState(-1, $GUI_DISABLE)
	  $infotext1 = GUICtrlCreateLabel("A new version of the following application is available" & @LF & "and needs to be installed", 15, 108, 380, 38, $SS_CENTER)
	  GUICtrlSetFont(-1, 12, 400, 0, "Calibri")
	  GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
	  $application_label = GUICtrlCreateLabel($Application, 15, 155, 380, 21, $SS_CENTER)
	  GUICtrlSetColor(-1, 0x0000FF)
	  GUICtrlSetFont(-1, 14, 800, 0, "Calibri")
	  GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
	  $infotext2 = GUICtrlCreateLabel("Please close the following applications and click OK to continue the installation", 15, 192, 380, 38, $SS_CENTER)
	  GUICtrlSetFont(-1, 12, 400, 0, "Calibri")
	  GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
	  GUICtrlCreateButton("", 18, 235, 372,125)
	  GUICtrlSetBkColor(-1, 0xFFFFFF)
	  GUICtrlSetState(-1, $GUI_DISABLE)
	  $process_label1 = GUICtrlCreateLabel($ProcessToClose1, 30, 245, 355, 21, $SS_LEFT)
	  GUICtrlSetFont(-1, 10, 400, 0, "Calibri")
	  GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
	  GUICtrlSetColor(-1, 0xFFFFFF)
	  $process_label2 = GUICtrlCreateLabel($ProcessToClose2, 30, 265, 355, 21, $SS_LEFT)
	  GUICtrlSetFont(-1, 10, 400, 0, "Calibri")
	  GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
	  GUICtrlSetColor(-1, 0xFFFFFF)
	  $process_label3 = GUICtrlCreateLabel($ProcessToClose3, 30, 285, 355, 21, $SS_LEFT)
	  GUICtrlSetFont(-1, 10, 400, 0, "Calibri")
	  GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
	  GUICtrlSetColor(-1, 0xFFFFFF)
	  $process_label4 = GUICtrlCreateLabel($ProcessToClose4, 30, 305, 355, 21, $SS_LEFT)
	  GUICtrlSetFont(-1, 10, 400, 0, "Calibri")
	  GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
	  GUICtrlSetColor(-1, 0xFFFFFF)
	  $ok_button = GUICtrlCreateButton("OK", 296, 376, 97, 33)
	  GUICtrlSetState(-1, $GUI_DISABLE)
	  $close_button = GUICtrlCreateButton("Close automatically the affected applications", 16, 376, 230, 33)
	  GUICtrlCreateButton("", 8, 420, 393, 80)
	  GUICtrlSetBkColor(-1, $iBkClr)
	  GUICtrlSetState(-1, $GUI_DISABLE)
	  $infotext3 = GUICtrlCreateLabel("If you dont want to interrupt your work now you can postpone this dialog up to (" & $postponeCounter & ") times.", 15, 425, 380, 38, $SS_CENTER)
	  GUICtrlSetFont(-1, 9, 400, 0, "Calibri")
	  GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
	  $infotext4 = GUICtrlCreateLabel("Please choose your preference!", 15, 454, 380, 21, $SS_CENTER)
	  GUICtrlSetFont(-1, 9, 400, 0, "Calibri")
	  GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
	  $infotext5 = GUICtrlCreateLabel("Remind me in:", 15, 470, 200, 21, $SS_CENTER)
	  GUICtrlSetFont(-1, 9, 400, 0, "Calibri")
	  GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
	  $postpone_combo = GUICtrlCreateCombo("30 Minutes", 160, 470, 100, 40)
	  GUICtrlSetData($postpone_combo, "60 Minutes|90 Minutes", "30 Minutes")
	  $postpone_button = GUICtrlCreateButton("Postpone", 280, 470, 100, 21)
	  GUISetState(@SW_SHOW, $Main)
#EndRegion ### END Koda GUI section ###

AdlibRegister("ProcessNameVisibility", 250)
;Old implementation AdlibRegister("OKButtonVisibility", 250)
AdlibRegister("_check_process", 250)

	While 1
		$nMsg = GUIGetMsg()

		Switch $nMsg
			Case $GUI_EVENT_CLOSE
				AdlibUnRegister()
				Exit

			Case $ok_button
				AdlibUnRegister()
				Exit

			Case $close_button
				$mybo1 = MsgBox ( 1+65536+48+262144, "CompanyName", "Are you sure you want to close the affected applications automatically?")
				If $mybo1 = 2 Then
					ContinueCase
				Else
				 ProcessClose($ProcessName1)
				 ProcessClose($ProcessName2)
				 ProcessClose($ProcessName3)
				 ProcessClose($ProcessName4)
				AdlibUnRegister()
				EndIf
				Exit

			Case $continue

			Case $postpone_button
				$sComboRead = GUICtrlRead($postpone_combo)
				$sString = StringLeft ($sComboRead,2)
				$sInt = Int($sString)* $postponeIntMultiplier

				WinSetState ( "CompanyName - Software Installation", "", @SW_HIDE )
				Sleep ($sInt)
				$postponeStatus = $postponeStatus +1
				updatePostponeCounter()
				postpone()
				WinSetState ( "CompanyName - Software Installation", "", @SW_SHOW )

		EndSwitch

	WEnd

EndIf

Func postpone()

	If $postponeStatus = 2 then
		GUICtrlSetState($postpone_combo, $GUI_DISABLE)
		GUICtrlSetState($postpone_button, $GUI_DISABLE)
		EndIf

EndFunc

Func updatePostponeCounter()

		$postponeCounter = $postponeCounter -1
	  GUICtrlSetData($infotext3, "If you dont want to interrupt your work now you can postpone this dialog up to (" & $postponeCounter & ") times.")

EndFunc

Func ProcessNameVisibility()

	  If ProcessExists ( $ProcessName1 ) Then
		 GUICtrlSetColor($process_label1, 0x000000)
	  else
		 GUICtrlSetColor($process_label1, 0xFFFFFF)
	  EndIf

	  If ProcessExists ( $ProcessName2 ) Then
		 GUICtrlSetColor($process_label2, 0x000000)
	  else
		 GUICtrlSetColor($process_label2, 0xFFFFFF)
	  EndIf

	  If ProcessExists ( $ProcessName3 ) Then
		GUICtrlSetColor($process_label3, 0x000000)
	  else
		 GUICtrlSetColor($process_label3, 0xFFFFFF)
	  EndIf

	  If ProcessExists ( $ProcessName4 ) Then
		 GUICtrlSetColor($process_label4, 0x000000)
	  else
		 GUICtrlSetColor($process_label4, 0xFFFFFF)
	  EndIf

   EndFunc

Func _check_process()

	 Switch ProcessExists ( $ProcessName1 ) Or  ProcessExists ( $ProcessName2 ) Or  ProcessExists ( $ProcessName3 ) Or  ProcessExists ( $ProcessName4 )
        Case 0

            If BitAND(GUICtrlGetState($ok_button), $gui_disable) = $gui_disable Then GUICtrlSetState($ok_button, $gui_enable)
        Case Else
            ;from ok_button
            If BitAND(GUICtrlGetState($ok_button), $gui_enable) = $gui_enable Then GUICtrlSetState($ok_button, $gui_disable)

	 EndSwitch
EndFunc

#comments-start
# old button visibility (flickering)

Func OKButtonVisibility()

   	  If ProcessExists ( $ProcessName1 ) Or  ProcessExists ( $ProcessName2 ) Or  ProcessExists ( $ProcessName3 ) Or  ProcessExists ( $ProcessName4 ) Then
		 GUICtrlSetState($ok_button, $GUI_DISABLE)
	  else
		 GUICtrlSetState($ok_button, $GUI_ENABLE)
	  EndIf



EndFunc
#comments-end